Index: trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.F	(revision 175)
@@ -1,5 +1,3 @@
-      SUBROUTINE optci_1pt(zqaer_1pt,iopti,
-     .            COSBI_1pt,DTAUI_1pt,TAUHI_1pt,TAUHID_1pt,TAUCI_1pt,
-     .            TAUGI_1pt,TAUGID_1pt,WBARI_1pt,TAUI_1pt,IPRINT)
+      SUBROUTINE optci_1pt(zqaer_1pt,rcdb,xfrb,iopti,IPRINT)
       use dimphy
 #include "dimensions.h"
@@ -16,12 +14,6 @@
 C iopti: premier appel, on ne calcule qu'une fois les QM et QF
 * nrad dans microtab.h
-      real   zqaer_1pt(NLAYER,nrad)
-      real   TAUHID_1pt(NLAYER,NSPECI)
-      real   TAUGID_1pt(NLAYER,NSPECI)
-      real   TAUHI_1pt(NSPECI),TAUCI_1pt(NSPECI)
-      real   TAUGI_1pt(NSPECI)
-      real   DTAUI_1pt(NLAYER,NSPECI),TAUI_1pt(NLEVEL,NSPECI)
-      real   WBARI_1pt(NLAYER,NSPECI)
-      real   COSBI_1pt(NLAYER,NSPECI)
+      real   zqaer_1pt(NLAYER,2*nrad)
+#include "optci_1pt.h"
 c   ---------
 
@@ -37,6 +29,9 @@
      & , REALI(NSPECI), XIMGI(NSPECI), REALV(NSPECV), XIMGV(NSPECV)
 
-      COMMON /CLOUD/ RADCLD(NLAYER), XNCLD(NLAYER)
-     & , RCLDI(NSPECI), XICLDI(NSPECI), RCLDV(NSPECV), XICLDV(NSPECV)
+      COMMON /CLOUD/
+     &               RCLDI(NSPECI), XICLDI(NSPECI)
+     &             , RCLDV(NSPECV), XICLDV(NSPECV)
+     &             , RCLDI2(NSPECI), XICLDI2(NSPECI)
+     &             , RCLDV2(NSPECV), XICLDV2(NSPECV)
 
       COMMON /SPECTI/ BWNI(NSPC1I), WNOI(NSPECI),
@@ -57,7 +52,13 @@
       REAL QM1(nrad,NSPECI),QM2(nrad,NSPECI)
       REAL QM3(nrad,NSPECI),QM4(nrad,NSPECI)
+      REAL QC1(nrad,NSPECI),QC2(nrad,NSPECI)
+      REAL QC3(nrad,NSPECI),QC4(nrad,NSPECI)
       real emu
       REAL TAEROSM1(NSPECI),TAEROSCATM1(NSPECI),DELTAZM1(NSPECI)
       
+c ---- nuages      
+      REAL TNUAGE,TNUAGESCAT
+      REAL rcdb(nlayer),xfrb(nlayer,4)
+
       save qf1,qf2,qf3,qf4,qm1,qm2,qm3,qm4
 
@@ -192,10 +193,10 @@
              if (iopti.eq.0) then
 
-       CALL OPTFRAC(XMONO,10000./WNOI(K)
-     &                         ,QEXT,QSCT,QABS,QBAR)
-
-
-c      CALL CFFFV11(1.e-2/WNOI(K),REALI(K),XIMGI(K),RF(inq),2.
-c    &                ,XMONO,QSCT,QEXT,QABS,QBAR)
+c       CALL OPTFRAC(XMONO,10000./WNOI(K)
+c     &                         ,QEXT,QSCT,QABS,QBAR)
+
+
+       CALL CFFFV11(1.e-2/WNOI(K),REALI(K),XIMGI(K),RF(inq),2.
+     &                ,XMONO,QSCT,QEXT,QABS,QBAR)
 
 
@@ -213,5 +214,4 @@
 
                IF(TAEROS.LT.1.e-10) TAEROS=1.e-10                                              
-
          ENDIF
        ENDDO             ! FIN DE LA BOUCLE SUR nrad
@@ -279,12 +279,82 @@
 
 C NEXT COMPUTE TAU CLOUD
-      TAUCLD=0.0
-      CBARC =0.0
-       IF ( XNCLD(J) .GT. 0..and .taufac.gt.0.) THEN
-         print*,'Appel a xmie avec radcld=',radcld(j)
-                CALL XMIE(RADCLD(J),RCLDI(K),XICLDI(K),
-     &                         QEXTC,QSCTC,QABSC,CBARC,WNOI(K))
-                TAUCLD=QEXTC*XNCLD(J)
+      IF (clouds.eq.0) THEN
+        TNUAGE=0.
+        TNUAGESCAT=0.
+        CNBAR=0.
+      ELSE
+        TNUAGE=0.
+        TNUAGESCAT=0.
+        CNBAR=0.
+        QEXTC=0.
+        QSCTC=0.
+        QABSC=0.
+        CBARC=0.
+
+        DO inq=1,nrad         !BOUCLE SUR LES NQMX TAILLE D"AEROSOLS
+          QC1(inq,K)=0.
+          QC2(inq,K)=0.
+          QC3(inq,K)=0.
+          QC4(inq,K)=0.
+        ENDDO
+
+** OPTICAL CONSTANT : MIXING RULES
+
+        IF (rcdb(nlayer+1-J).gt.1.1e-10) THEN
+
+          XNR=xfrb(nlayer+1-J,1) *REALI(K)
+     &    +xfrb(nlayer+1-J,2) *RCLDI(K)
+     &    +xfrb(nlayer+1-J,3) *RCLDI2(K)
+     &    +xfrb(nlayer+1-J,4) *RCLDI2(K)
+
+          XNI=xfrb(nlayer+1-J,1) *XIMGI(K)
+     &    +xfrb(nlayer+1-J,2) *XICLDI(K)
+     &    +xfrb(nlayer+1-J,3) *XICLDI2(K)
+     &    +xfrb(nlayer+1-J,4) *XICLDI2(K)
+
+** OPTICAL CONSTANT : LIQUID DROP = THOLIN
+
+          IF(xfrb(nlayer+1-J,1).ge.0.1) THEN
+            XNI=XIMGI(K)
+            XNR=REALI(K)
+          ENDIF
+
+          IF (XNI.gt.1.e-10  .and. XNR.gt.1.00) THEN
+            CALL CMIE(1.E-2/WNOI(K),XNR,XNI,
+     &      rcdb(nlayer+1-J),
+     &      QEXTC,QSCTC,QABSC,CBARC)
+          ELSE
+            PRINT*,' WARNING XNR/XNI in optci: ',XNR,XNI
+            QEXTC=0.
+            QSCTC=0.
+            QABSC=0.
+            CBARC=0.
+          ENDIF
+        ELSE
+          QEXTC=0.
+          QSCTC=0.
+          QABSC=0.
+          CBARC=0.
         ENDIF
+
+        DO inq=1,nrad         !BOUCLE SUR LES NQMX TAILLE D"AEROSOLS
+          QC1(inq,K)=QEXTC/xnuf
+          QC2(inq,K)=QSCTC/xnuf
+          QC3(inq,K)=QABSC/xnuf
+          QC4(inq,K)=CBARC
+          TNUAGE=QC1(inq,K)*zqaer_1pt(nlayer+1-J,inq+nrad)*1.e-4
+     &          +TNUAGE
+          TNUAGESCAT=QC2(inq,K)*zqaer_1pt(nlayer+1-J,inq+nrad)*1.e-4
+     &              +TNUAGESCAT
+          CNBAR=QC4(inq,K)*QC2(inq,K)
+     &         *zqaer_1pt(nlayer+1-J,inq+nrad)*1.e-4+CNBAR
+        ENDDO
+
+        IF(TNUAGESCAT.EQ.0.) THEN
+             CNBAR=0.
+        ELSE
+             CNBAR=CNBAR/TNUAGESCAT
+        ENDIF
+      ENDIF    ! Cond CLD
 
 
@@ -329,54 +399,51 @@
 C
 
-      IF (TAEROS + TAUCLD .GT. 0.) THEN
-         COSBI_1pt(J,K)=(CBAR*TAEROSCAT + CBARC*TAUCLD )
-     &                     /(TAEROSCAT + TAUCLD)
+      DTAUI_1pt(J,K)=TAUGAS+TAEROS+TNUAGE
+      DTAUIP_1pt(J,K)=TAUGAS+TAEROS
+
+      TAUHI_1pt(K)=TAUHI_1pt(K) + TAEROS
+      TAUHID_1pt(J,K)=TAUHI_1pt(K)
+
+      TAUGI_1pt(K)=TAUGI_1pt(K) + TAUGAS
+      TAUGID_1pt(J,K)=TAUGI_1pt(K)
+
+      TAUCI_1pt(K)=TAUCI_1pt(K) + TNUAGE
+      TAUCID_1pt(J,K)=TAUCI_1pt(K)
+ 
+C ??FLAG? SERIOUS PROBLEM WITH THE CODE HERE!
+
+      TLIMIT=1.E-16
+
+
+      IF (TAEROSCAT + TNUAGESCAT .GT. 0.) THEN
+         COSBI_1pt(J,K)=(CBAR*TAEROSCAT + CNBAR*TNUAGESCAT )
+     &                     /(TAEROSCAT + TNUAGESCAT)
       ELSE
          COSBI_1pt(J,K)=0.0
       ENDIF
 
-      DTAUI_1pt(J,K)=TAUGAS+TAEROS+TAUCLD
-
-      TAUHI_1pt(K)=TAUHI_1pt(K) + TAEROS
-      TAUHID_1pt(J,K)=TAUHI_1pt(K)
-
-      TAUGI_1pt(K)=TAUGI_1pt(K) + TAUGAS
-      TAUGID_1pt(J,K)=TAUGI_1pt(K)
-
-      TAUCI_1pt(K)=TAUCI_1pt(K) + TAUCLD
- 
-c     if (ig.eq.1) then
-c     if (k.eq.NSPECI/2.or.k.eq.1.or.k.eq.NSPECI) then
-c      print*,'@IR',K,J,DTAUI_1pt(J,K),TAUGAS,TAEROS,TAUCLD         
-c     endif
-c     endif
-
-
-C ??FLAG? SERIOUS PROBLEM WITH THE CODE HERE!
-
-      TLIMIT=1.E-16
-
-      IF (DTAUI_1pt(J,K) .GT. TLIMIT) THEN
-
-c***************** ECHANGE 
-c        WBARI(J,K)=(QSCT*XNUMB(J) + QSCTC*XNCLD(J))
-c****************
-CFC        WBARI_1pt(J,K)=(TAEROSCAT + QSCTC*XNCLD(J))
-c****************
-           WBARI_1pt(J,K)=TAEROSCAT
-     &   /DTAUI_1pt(J,K)
-c        if(iwarning.eq.0) 
-c     s   print*,'WARNING!!! dans optci xncld non initialise'
-c        iwarning=1
-
+      IF (TAEROSCAT  .GT. 0.) THEN
+         COSBIP_1pt(J,K)=(CBAR*TAEROSCAT)
+     &                     /(TAEROSCAT)
       ELSE
-
+         COSBIP_1pt(J,K)=0.0
+      ENDIF
+
+*---------
+
+      IF (DTAUI_1pt(J,K) .GT.  TLIMIT) THEN
+          WBARI_1pt(J,K)=(TAEROSCAT+TNUAGESCAT) /DTAUI_1pt(J,K)
+      ELSE
          WBARI_1pt(J,K)=0.0
-c        PRINT*,'gaz ',taugas,'aerosols',taeros,'nuages',taucld
-c        WRITE (6,999) J,K,DTAUI_1pt(J,K)
- 999     FORMAT ('  WARNING TAU MINIMUM AT J,K,DTAU:',2I3,1PE10.3)
          DTAUI_1pt(J,K)=TLIMIT
-
       ENDIF
+
+      IF (DTAUIP_1pt(J,K) .GT.  TLIMIT) THEN
+          WBARIP_1pt(J,K)=(TAEROSCAT) /DTAUIP_1pt(J,K)
+      ELSE
+         WBARIP_1pt(J,K)=0.0
+         DTAUIP_1pt(J,K)=TLIMIT
+      ENDIF
+
 
 c     IF (IPRINT .GT. 9)
@@ -397,6 +464,8 @@
         DO 119 K=1,NSPECI
            TAUI_1pt(1,K)=0.0
+           TAUIP_1pt(1,K)=0.0
         DO 119 J=1,NLAYER
            TAUI_1pt(J+1,K)=TAUI_1pt(J,K)+DTAUI_1pt(J,K)
+           TAUIP_1pt(J+1,K)=TAUIP_1pt(J,K)+DTAUIP_1pt(J,K)
  119    CONTINUE
 
Index: trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.h	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/optci_1pt.h	(revision 175)
@@ -0,0 +1,47 @@
+!----------------------------------------------
+! fichier optci_1p.h
+!
+!  regroupe les sorties du fichier optci_1pt
+!  les nuages oblige a quasiment doubler
+!  le nombre de variables c'est juste pour
+!  la lisibilite.
+!----------------------------------------------
+
+! ----DIAGNOSTIQUES
+      real   TAUHID_1pt(NLAYER,NSPECI)
+      real   TAUCID_1pt(NLAYER,NSPECI)
+      real   TAUGID_1pt(NLAYER,NSPECI)
+! ----OPACITES TOTALES
+      real   TAUHI_1pt(NSPECI)
+      real   TAUCI_1pt(NSPECI)
+      real   TAUGI_1pt(NSPECI)
+! ----COLONNE NUAGEUSE
+      real   DTAUI_1pt(NLAYER,NSPECI)
+      real   TAUI_1pt(NLEVEL,NSPECI)
+      real   WBARI_1pt(NLAYER,NSPECI)
+      real   COSBI_1pt(NLAYER,NSPECI)
+! ----COLONNE "CLAIRE"
+      real   DTAUIP_1pt(NLAYER,NSPECI)
+      real   TAUIP_1pt(NLEVEL,NSPECI)
+      real   WBARIP_1pt(NLAYER,NSPECI)
+      real   COSBIP_1pt(NLAYER,NSPECI)
+
+
+      common/opti_1pt/                                                  &
+     &        TAUHID_1pt                                                &
+     &       ,TAUCID_1pt                                                &
+     &       ,TAUGID_1pt                                                &
+! ----OPACITES TOTALES
+     &       ,TAUHI_1pt                                                 &
+     &       ,TAUCI_1pt                                                 &
+     &       ,TAUGI_1pt                                                 &
+! ----COLONNE NUAGEUSE
+     &       ,DTAUI_1pt                                                 &
+     &       ,TAUI_1pt                                                  &
+     &       ,WBARI_1pt                                                 &
+     &       ,COSBI_1pt                                                 &
+! ----COLONNE "CLAIRE"
+     &       ,DTAUIP_1pt                                                &
+     &       ,TAUIP_1pt                                                 &
+     &       ,WBARIP_1pt                                                &
+     &       ,COSBIP_1pt
Index: trunk/LMDZ.TITAN/libf/phytitan/optci_1pt_2.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optci_1pt_2.F	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/optci_1pt_2.F	(revision 175)
@@ -0,0 +1,480 @@
+      SUBROUTINE optci_1pt2(zqaer_1pt,rcdb,xfrb,iopti,IPRINT)
+
+      use dimphy
+#include "dimensions.h"
+#include "microtab.h"
+#include "numchimrad.h"
+#include "clesphys.h"
+
+      PARAMETER(NLAYER=llm,NLEVEL=NLAYER+1)
+      PARAMETER (NSPECI=46,NSPC1I=47,NSPECV=24,NSPC1V=25)
+
+c   Arguments:
+c   ---------
+      integer IPRINT,iopti
+C iopti: premier appel, on ne calcule qu'une fois les QM et QF
+* nrad dans microtab.h
+      real   zqaer_1pt(NLAYER,2*nrad)
+#include "optci_1pt.h"
+c   ---------
+
+      COMMON /ATM/ Z(NLEVEL),PRESS(NLEVEL),DEN(NLEVEL),TEMP(NLEVEL)
+
+      COMMON /GASS/ CH4(NLEVEL),XN2(NLEVEL),H2(NLEVEL),AR(NLEVEL)
+     & ,XMU(NLEVEL),GAS1(NLAYER),COLDEN(NLAYER)
+
+      COMMON /STRATO/ C2H2(NLAYER),C2H6(NLAYER)
+      COMMON /STRAT2/ HCN(NLAYER)
+
+      COMMON /AERSOL/ RADIUS(NLAYER), XNUMB(NLAYER)
+     & , REALI(NSPECI), XIMGI(NSPECI), REALV(NSPECV), XIMGV(NSPECV)
+
+      COMMON /CLOUD/
+     &               RCLDI(NSPECI), XICLDI(NSPECI)
+     &             , RCLDV(NSPECV), XICLDV(NSPECV)
+     &             , RCLDI2(NSPECI), XICLDI2(NSPECI)
+     &             , RCLDV2(NSPECV), XICLDV2(NSPECV)
+
+      COMMON /SPECTI/ BWNI(NSPC1I), WNOI(NSPECI),
+     &                DWNI(NSPECI), WLNI(NSPECI)
+
+      COMMON /PLANT/ CSUBP,RSFI,RSFV,F0PI
+      COMMON /ADJUST/ RHCH4,FH2,FHAZE,FHVIS,FHIR,TAUFAC,RCLOUD,FARGON
+      COMMON /CONST/RGAS,RHOP,PI,SIGMA
+      COMMON /part/v,rayon,vrat,dr,dv
+
+      DIMENSION PROD(NLEVEL)
+* nrad dans microtab.h
+      real v(nrad),rayon(nrad),vrat,dr(nrad),dv(nrad)
+      real xv1(klev,nspeci),xv2(klev,nspeci)
+      real xv3(klev,nspeci)
+      REAL QF1(nrad,NSPECI),QF2(nrad,NSPECI)
+      REAL QF3(nrad,NSPECI),QF4(nrad,NSPECI)
+      REAL QM1(nrad,NSPECI),QM2(nrad,NSPECI)
+      REAL QM3(nrad,NSPECI),QM4(nrad,NSPECI)
+      REAL QC1(nrad,NSPECI),QC2(nrad,NSPECI)
+      REAL QC3(nrad,NSPECI),QC4(nrad,NSPECI)
+      real emu
+      REAL TAEROSM1(NSPECI),TAEROSCATM1(NSPECI),DELTAZM1(NSPECI)
+
+c ---- nuages      
+      REAL TNUAGE,TNUAGESCAT
+      REAL rcdb(nlayer),xfrb(nlayer,4)
+
+      save qf1,qf2,qf3,qf4,qm1,qm2,qm3,qm4,qc1,qc2,qc3,qc4
+
+
+C THE PRESSURE INDUCED TRANSITIONS ARE FROM REGIS
+C THE LAST SEVENTEEN INTERVALS ARE THE BANDS FROM GNF.
+C
+C THIS SUBROUTINE SETS THE OPTICAL CONSTANTS IN THE INFRARED
+C IT CALCUALTES FOR EACH LAYER, FOR EACH SPECRAL INTERVAL IN THE IR
+C LAYER: WBAR, DTAU, COSBAR
+C LEVEL: TAU
+C
+
+        DO 80 K=1,NSPECI
+           TAUHI_1pt(K)=0.
+           TAUCI_1pt(K)=0.
+           TAUGI_1pt(K)=0.
+ 80     CONTINUE
+
+c************************************************************************
+          DO 100 J=1,NLAYER    ! BOUCLE SUR L'ALTITUDE
+c************************************************************************
+
+C SET UP THE COEFFICIENT TO REDUCE MASS PATH TO STP ...SEE NOTES
+C T0 =273.15   PO=1.01325 BAR
+
+        TBAR=0.5*(TEMP(J)+TEMP(J+1))
+        PBAR=SQRT(PRESS(J)*PRESS(J+1))
+        BMU=0.5*(XMU(J+1)+XMU(J))
+        COEF1=RGAS*273.15**2*.5E5* (PRESS(J+1)**2 - PRESS(J)**2)
+     & /(1.01325**2 *EFFG(Z(J))*TBAR*BMU)
+
+      IF (IPRINT .GT. 9) WRITE(6,21) J,EFFG(Z(J)),TBAR,BMU,COEF1
+ 21   FORMAT(' J, EFFG, TBAR, BMU, COEF1,: ',I3,1P6E10.3)
+
+c------------------------------------------------------------------------
+         DO 101 K=1,NSPECI     ! BOUCLE SUR LES L.D'O
+c------------------------------------------------------------------------
+
+
+C #1:             HAZE
+C---------------------
+
+C FIRST COMPUTE TAU AEROSOL
+
+
+c
+c                    /\
+c                   /  \
+c                  /    \
+c                 / _O   \
+c                / |/     \
+c               /  / \     \
+c              /   |\ \/\   \
+c             /    || /  \   \
+c             ----------------
+c            |     WARNING    |
+c            |    SLOW DOWN   |
+c             ---------------- 
+
+
+
+
+c*********** EN TRAVAUX ***************************
+
+         TAEROS=0.
+         TAEROSCAT=0.
+         CBAR=0.
+
+
+      DO inq=1,nrad         !BOUCLE SUR LES TAILLE D"AEROSOLS
+
+
+      IF (WNOI(K).lt.wco) THEN    ! lamda > 56 um
+
+           if (iopti.eq.0) then
+
+c          CALL XMIE(rayon(inq)*1.e6,REALI(K),XIMGI(K),
+c    &     QEXT,QSCT,QABS,QBAR,WNOI(K))
+
+           CALL CMIE(1.E-2/WNOI(K),REALI(K),XIMGI(K),rayon(inq),
+     &     QEXT,QSCT,QABS,QBAR)
+
+
+           QM1(inq,K)=QEXT
+           QM2(inq,K)=QSCT
+           QM3(inq,K)=QABS
+           QM4(inq,K)=QBAR
+
+          endif         ! end iopti
+
+
+      TAEROS=QM1(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4+TAEROS
+      TAEROSCAT=QM2(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4+TAEROSCAT
+      CBAR=CBAR+QM4(inq,K)*QM2(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4
+
+
+         ELSE                           ! 0.2 < lambda < 56 um
+
+
+            if(rayon(inq).lt.RF(inq)) THEN
+
+              if (iopti.eq.0) then
+
+                   CALL XMIE(rayon(inq)*1.e6,REALI(K),XIMGI(K),
+     &             QEXT,QSCT,QABS,QBAR,WNOI(K))
+
+              QM1(inq,K)=QEXT
+              QM2(inq,K)=QSCT
+              QM3(inq,K)=QABS
+              QM4(inq,K)=QBAR
+              endif         ! end iopti
+
+
+        TAEROS=QM1(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4+TAEROS
+        TAEROSCAT=QM2(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4+TAEROSCAT
+        CBAR=CBAR+QM4(inq,K)*QM2(inq,K)*zqaer_1pt(nlayer+1-J,inq)*1.e-4
+
+           else
+
+               XMONO=(rayon(inq)/RF(inq))**3.
+               XRULE=1.
+
+            if(XMONO.gt.16384./1.5) then
+             XRULE=(XMONO/16384.)
+             XMONO=16384.
+            endif
+
+
+             if (iopti.eq.0) then
+
+c       CALL OPTFRAC(XMONO,10000./WNOI(K)
+c     &                         ,QEXT,QSCT,QABS,QBAR)
+
+
+       CALL CFFFV11(1.e-2/WNOI(K),REALI(K),XIMGI(K),RF(inq),2.
+     &                ,XMONO,QSCT,QEXT,QABS,QBAR)
+
+
+              QF1(inq,K)=QEXT*XRULE
+              QF2(inq,K)=QSCT*XRULE
+              QF3(inq,K)=QABS*XRULE
+              QF4(inq,K)=QBAR
+             endif         ! end iopti
+
+        TAEROS=QF1(inq,K)*zqaer_1pt(nlayer+1-J,inq)+TAEROS
+        TAEROSCAT=QF2(inq,K)*zqaer_1pt(nlayer+1-J,inq)+TAEROSCAT
+        CBAR=CBAR+QF4(inq,K)*QF2(inq,K)*zqaer_1pt(nlayer+1-J,inq)
+
+           endif
+
+               IF(TAEROS.LT.1.e-10) TAEROS=1.e-10
+
+         ENDIF
+       ENDDO             ! FIN DE LA BOUCLE SUR nrad
+
+       IF(TAEROSCAT.le.0.) then
+        CBAR=0.
+       ELSE
+        CBAR=CBAR/TAEROSCAT
+       ENDIF
+
+        DELTAZ=Z(J)-Z(J+1)
+
+c --------------------------------------------------------------------
+c profil brume Pascal: fit T (sauf tropopause) et albedo
+c -------------------
+        if( cutoff.eq.1) then
+         IF(PRESS(J).gt.9.e-3) THEN
+          TAEROS=TAEROSM1(K)*DELTAZ/DELTAZM1(K)*0.85
+          TAEROSCAT=TAEROSCATM1(K)*DELTAZ/DELTAZM1(K)*0.85
+c         TAEROS=0.
+c         TAEROSCAT=0.
+         ENDIF
+
+         IF(PRESS(J).gt.1.e-1) THEN
+          TAEROS=TAEROSM1(K)*DELTAZ/DELTAZM1(K)*1.15
+          TAEROSCAT=TAEROSCATM1(K)*DELTAZ/DELTAZM1(K)*1.15
+c         TAEROS=0.
+c         TAEROSCAT=0.
+         ENDIF
+        endif !cutoff=1
+
+c profil brume pour fit T (y compris tropopause), mais ne fit plus albedo...
+c -----------------------
+        if( cutoff.eq.2) then
+         IF(PRESS(J).gt.1.e-1) THEN
+          TAEROS=0.
+          TAEROSCAT=0.
+         ENDIF
+        endif !cutoff=2
+c --------------------------------------------------------------------
+
+         TAEROSM1(K)=TAEROS
+         TAEROSCATM1(K)=TAEROSCAT
+         DELTAZM1(K)=DELTAZ
+
+
+      IF(TAEROSCAT.le.0.) CBAR=0.
+
+c     print*,'HERE, MCKAY AEROSOLS IR'
+c     TAEROS=xv1(j,k)
+c     TAEROSCAT=xv2(j,k)
+c     CBAR=xv3(j,k)
+
+c*********** EN TRAVAUX ***************************
+
+C #2:         CLOUD
+C------------------
+C NEXT COMPUTE TAU CLOUD
+c
+c  Menu special :
+c  Afin d'eviter la surcharge de calcul on ne calcule les 
+c  propriétes optiques des nuages qu'une seule fois
+c  avec un rayon de particule effectif de 3um et une composition
+c  de goutte : 90% CH4 / 10% NOYAUX
+c  Puis on ajute les section efficace par la surface reelle de 
+c  la goutte.
+c
+c  ---> A TESTER !!!!
+c
+        TNUAGE=0.
+        TNUAGESCAT=0.
+        CNBAR=0.
+        IF (clouds.eq.1) THEN
+          IF (iopti.eq.0) THEN !--> au premier appel
+            QEXTC=0.
+            QSCTC=0.
+            QABSC=0.
+            CBARC=0.
+            DO inq=1,nrad         !BOUCLE SUR LES NQMX TAILLE D"AEROSOLS
+              QC1(inq,K)=0.
+              QC2(inq,K)=0.
+              QC3(inq,K)=0.
+              QC4(inq,K)=0.
+            ENDDO
+** OPTICAL CONSTANT : MIXING RULES
+** Fraction volumique fixe :
+** 10% noyaux.
+** 90% methane.
+            XNR = 0.5 * REALI(K)
+     &          + 0.5 * RCLDI(K)
+            XNI = 0.5 * XIMGI(K)
+     &          + 0.5 * XICLDI(K)
+**
+**   Efficacite : particule de 3um de rayon
+            CALL CMIE(1.E-2/WNOI(K),XNR,XNI,3.e-6,
+     &                QEXTC,QSCTC,QABSC,CBARC)
+**
+**   ATTENTION CE SONT DES EFFICACITES : il faut les x par la surface REELLE de la goutte.
+            DO inq=1,nrad
+              QC1(inq,K)=QEXTC/xnuf
+              QC2(inq,K)=QSCTC/xnuf
+              QC3(inq,K)=QABSC/xnuf
+              QC4(inq,K)=CBARC
+            ENDDO
+          ENDIF   ! iopti = 0
+
+c ----- On ne calcule les constante optiques que si Rgoutte > 1e-10
+          IF (rcdb(nlayer+1-J).gt.1.1e-10) THEN
+            DO inq=1,nrad        
+              TNUAGE=QC1(inq,K)*(rcdb(nlayer+1-J)/3.e-6)**2.*1.e-4*
+     &               zqaer_1pt(nlayer+1-J,inq+nrad) +
+     &               TNUAGE
+              TNUAGESCAT=QC2(inq,K)*(rcdb(nlayer+1-J)/3.e-6)**2.*
+     &                   1.e-4*zqaer_1pt(nlayer+1-J,inq+nrad) +
+     &                   TNUAGESCAT
+              CNBAR=QC4(inq,K)*QC2(inq,K)*
+     &              (rcdb(nlayer+1-J)/3.e-6)**2.*
+     &              1.e-4*zqaer_1pt(nlayer+1-J,inq+nrad) +
+     &              CNBAR
+            ENDDO
+          ENDIF
+
+          IF(TNUAGESCAT.EQ.0.) THEN
+            CNBAR=0.
+          ELSE
+            CNBAR=CNBAR/TNUAGESCAT
+          ENDIF
+
+        ENDIF    ! Cond CLD
+c
+C #3:          GAZ
+C------------------
+
+C NOW COMPUTE TAUGAS DUE TO THE PIA TERM ONLY FOR LAMDA LT 940
+       TAUGAS=0.0
+       IF (WNOI(K) .LT. 940. ) THEN
+                 CALL PIA(K,TBAR,PNN,PCC,PCN,PHN)
+C HERE IS WHERE WE COULD SCALE THE PIA COEFFICEINTS TO FIT DATA
+C BASED ON REGIS' NOTES. ---TGM HAS THIS ADJUST IN IT AS DEFAULT
+                 PCN=PCN*MIN(1.75 , AMAX1(1.0,WNOI(K)/200.))
+C***REPLACE ABOVE WITH: PCN=PCN*1.25*MIN(1.75 , AMAX1(1.0,WNOI(K)/200.))
+C 1.25 FACTOR (NOT FROM DATA) SUGGESTED BY TOON et al. (1988)
+                 TAUGAS=COEF1*
+     &           (XN2(J)*XN2(J)*PNN + CH4(J)*CH4(J)*PCC
+     &           + XN2(J)*CH4(J)*PCN + XN2(J)*H2(J)*PHN)
+            IF (J .EQ. NLAYER .AND. IPRINT .GT. 9)
+     &          WRITE (6,22) WNOI(K),TAUGAS,XN2(J),CH4(J),H2(J),
+     &          TBAR, PNN,PCC,PCN, PHN,
+     &          XN2(J)*XN2(J)*PNN , CH4(J)*CH4(J)*PCC ,
+     &          XN2(J)*CH4(J)*PCN , XN2(J)*H2(J)*PHN
+ 22             FORMAT(1X,1P8E10.2)
+       ENDIF
+
+       IF (K .GT. 28) THEN
+                KGAS=K-28
+C     ??FLAG? HERE MUST BE WATCHED CAREFULLY
+                     U=COLDEN(J)*6.02204E23/BMU
+                     if((ylellouch).or.(.not.hcnrad)) then
+                       CALL GAS2_NOHCN(J, KGAS,TBAR,PBAR,U,TAU2)
+                     else
+                       CALL GAS2(J, KGAS,TBAR,PBAR,U,TAU2)
+                     endif
+                     TAUGAS=TAUGAS+TAU2
+       ENDIF
+C
+
+      DTAUI_1pt(J,K)=TAUGAS+TAEROS+TNUAGE
+      DTAUIP_1pt(J,K)=TAUGAS+TAEROS
+
+      TAUHI_1pt(K)=TAUHI_1pt(K) + TAEROS
+      TAUHID_1pt(J,K)=TAUHI_1pt(K)
+
+      TAUGI_1pt(K)=TAUGI_1pt(K) + TAUGAS
+      TAUGID_1pt(J,K)=TAUGI_1pt(K)
+
+      TAUCI_1pt(K)=TAUCI_1pt(K) + TNUAGE
+      TAUCID_1pt(J,K)=TAUCI_1pt(K)
+ 
+C ??FLAG? SERIOUS PROBLEM WITH THE CODE HERE!
+
+      TLIMIT=1.E-16
+
+
+      IF (TAEROSCAT + TNUAGESCAT .GT. 0.) THEN
+         COSBI_1pt(J,K)=(CBAR*TAEROSCAT + CNBAR*TNUAGESCAT )
+     &                     /(TAEROSCAT + TNUAGESCAT)
+      ELSE
+         COSBI_1pt(J,K)=0.0
+      ENDIF
+
+      IF (TAEROSCAT  .GT. 0.) THEN
+         COSBIP_1pt(J,K)=(CBAR*TAEROSCAT)
+     &                     /(TAEROSCAT)
+      ELSE
+         COSBIP_1pt(J,K)=0.0
+      ENDIF
+
+*---------
+
+      IF (DTAUI_1pt(J,K) .GT.  TLIMIT) THEN
+          WBARI_1pt(J,K)=(TAEROSCAT+TNUAGESCAT) /DTAUI_1pt(J,K)
+      ELSE
+         WBARI_1pt(J,K)=0.0
+         DTAUI_1pt(J,K)=TLIMIT
+      ENDIF
+
+      IF (DTAUIP_1pt(J,K) .GT.  TLIMIT) THEN
+          WBARIP_1pt(J,K)=(TAEROSCAT) /DTAUIP_1pt(J,K)
+      ELSE
+         WBARIP_1pt(J,K)=0.0
+         DTAUIP_1pt(J,K)=TLIMIT
+      ENDIF
+
+
+c     IF (IPRINT .GT. 9)
+c    & WRITE(6,73)J,K,TAUGAS,TAEROS,QEXT,QSCT
+  73           FORMAT(2I3,1P8E10.3)
+ 
+
+c------------------------------------------------------------------------
+ 101  CONTINUE   ! FIN BOUCLE L D'O
+c------------------------------------------------------------------------
+ 
+      iopti=1
+
+c************************************************************************
+ 100  CONTINUE   ! FIN BOUCLE ALTITUDE
+c************************************************************************
+ 
+        DO 119 K=1,NSPECI
+           TAUI_1pt(1,K)=0.0
+           TAUIP_1pt(1,K)=0.0
+        DO 119 J=1,NLAYER
+           TAUI_1pt(J+1,K)=TAUI_1pt(J,K)+DTAUI_1pt(J,K)
+           TAUIP_1pt(J+1,K)=TAUIP_1pt(J,K)+DTAUIP_1pt(J,K)
+ 119    CONTINUE
+
+c      IF (IPRINT .GT. 2) THEN
+c          WRITE (6,120)
+c  120      FORMAT(///'  OPTICAL CONSTANTS IN THE INFRARED')
+
+c        DO 200 K=1,NSPECI           ! #2
+c          WRITE (6,190)
+c          WRITE (6,210)K,WLNI(K),WNOI(K),BWNI(K)
+c    &    ,BWNI(K)+DWNI(K),DWNI(K)
+c          WRITE (6,230)REALI(K),XIMGI(K)
+
+c        DO 195 J=1,NLAYER         !   #3
+c          WRITE (6,220)XNUMB(J), WBARI_1pt(J,K),COSBI_1pt(J,K)
+c    &                          , DTAUI_1pt(J,K),TAUI_1pt(J,K)
+c 195    CONTINUE
+
+c 200    CONTINUE
+
+c          END IF
+
+
+c  210 FORMAT(1X,I3,F10.3,F10.2,F10.2,'-',F8.2,F10.3)
+c  190 FORMAT(1X//'  SNUM  MICRONS   WAVENU   INTERVAL    DELTA-WN')
+c  230 FORMAT(1X,'NREAL(LAYER)= ',1PE10.3,' NIMG(LAYER)= ',E10.3/
+c     &' #AEROSOLS   WBAR  COSBAR DTAU TAU')
+c  220 FORMAT(5(1X,G9.3))
+c  240 FORMAT(41X,G9.3)
+
+      RETURN
+      END
Index: trunk/LMDZ.TITAN/libf/phytitan/optcv.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optcv.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/optcv.F	(revision 175)
@@ -31,7 +31,9 @@
      & , REALI(NSPECI), XIMGI(NSPECI), REALV(NSPECV), XIMGV(NSPECV)
 
-      COMMON /CLOUD/ RADCLD(NLAYER), XNCLD(NLAYER)
-     &             , RCLDI(NSPECI), XICLDI(NSPECI)
+      COMMON /CLOUD/ 
+     &               RCLDI(NSPECI), XICLDI(NSPECI)
      &             , RCLDV(NSPECV), XICLDV(NSPECV)
+     &             , RCLDI2(NSPECI), XICLDI2(NSPECI)
+     &             , RCLDV2(NSPECV), XICLDV2(NSPECV)
 
       COMMON /TAUS/   TAUHI(ngrid,NSPECI), TAUCI(ngrid,NSPECI)
@@ -41,6 +43,8 @@
 
       COMMON /TAUD/   TAUHID(ngrid,NLAYER,NSPECI)
+     &               ,TAUCID(ngrid,NLAYER,NSPECI)
      &               ,TAUGID(ngrid,NLAYER,NSPECI)
      &               ,TAUHVD(ngrid,NLAYER,NSPECV)
+     &               ,TAUCVD(ngrid,NLAYER,NSPECV)
      &               ,TAUGVD(ngrid,NLAYER,NSPECV)
 
@@ -49,4 +53,8 @@
      &               ,WBARV(ngrid,NLAYER,NSPECV,4)
      &               ,COSBV(ngrid,NLAYER,NSPECV,4)
+     &               ,DTAUVP(ngrid,NLAYER,NSPECV,4)
+     &               ,TAUVP(ngrid,NLEVEL,NSPECV,4)
+     &               ,WBARVP(ngrid,NLAYER,NSPECV,4)
+     &               ,COSBVP(ngrid,NLAYER,NSPECV,4)
 
       COMMON /SPECTV/ BWNV(NSPC1V),WNOV(NSPECV) 
@@ -57,4 +65,11 @@
       COMMON /CONST/ RGAS,RHOP,PI,SIGMA
       COMMON /part/ v(nrad),rayon(nrad),vrat,dr(nrad),dv(nrad)
+
+c-----Rayons nuages et "composition" de la goutte
+c     sur la grille ...
+      integer ncount(ngrid,NLAYER)
+      real    rmcbar(ngrid,NLAYER)
+      real    xfbar(ngrid,NLAYER,4)
+      COMMON/rnuabar/ncount,rmcbar,xfbar
 
       REAL xv1(klev,NSPECV)
@@ -74,12 +89,7 @@
       data ioptv,iwarning,seulmtunpt/0,0,0/
 
-      real   zqaer_1pt(NLAYER,nrad)
-      real   TAUHVD_1pt(NLAYER,NSPECV)
-      real   TAUGVD_1pt(NLAYER,NSPECV)
-      real   TAUHV_1pt(NSPECV),TAUCV_1pt(NSPECV)
-      real   TAURV_1pt(NSPECV),TAUGV_1pt(NSPECV)
-      real   DTAUV_1pt(NLAYER,NSPECV,4),TAUV_1pt(NLEVEL,NSPECV,4)
-      real   WBARV_1pt(NLAYER,NSPECV,4)
-      real   COSBV_1pt(NLAYER,NSPECV,4)
+      real   zqaer_1pt(NLAYER,2*nrad)
+#include "optcv_1pt.h"
+
       character*100 dummy
       real   dummy2,dummy3
@@ -87,5 +97,5 @@
 C*
 C THIS SUBROUTINE SETS THE OPTICAL CONSTANTS IN THE VISIBLE
-C IT CALCUALTES FOR EACH LAYER, FOR EACH SPECRAL INTERVAL IN THE VIS
+C IT CALCULATES FOR EACH LAYER, FOR EACH SPECRAL INTERVAL IN THE VIS
 C LAYER: WBAR, DTAU, COSBAR
 C LEVEL: TAU
@@ -95,14 +105,4 @@
        print*,'ATTENTION, TAU UNIFORME DANS OPTCV'
 
-c      do nng=2,klon
-c       do i=1,klev           
-c        do j=1,nqtot
-c          sum=sum+qaer(nng,i,j)*rayon(j)**3.*1.3333*3.1415*1000.
-c        enddo
-c       enddo
-c       enddo
-c       print*,sum/(klon-1),'SOMME COLONNE/OPTCV'
-
-             
 C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 c INITIALISATIONS UNE SEULE FOIS
@@ -114,10 +114,23 @@
 c il faut quand meme qu'on lise la look-up table de dim nrad=10
 c et si microfi=1, on doit avoir nmicro=nrad (dans microtab.h)
-       if ((nmicro.ne.nrad).and.(microfi.eq.1)) then
-          print*,"nmicro.ne.nrad",nmicro,nrad
-	  print*,"PROBLEME pour zqaer_1pt dans optcv !!"
-	  stop
+c 
+c Nouvelle verif pour nuages : 
+c La condition ci-dessus n'est plus realisable !
+c nmicro comprend maintenant aussi des glaces
+c Donc on teste juste que nmicro soit > 2*nrad (ou nrad si on ne fait pas de nuages)
+       if (microfi.ge.1) then
+         if ((clouds.eq.1).and.(nmicro.lt.2*nrad)) then
+           print*,"OPTCV :"
+           print*,"clouds = 1 MAIS nmicro < 2*nrad"
+           print*,"Probleme pour zqaer_1pt dans optcv."
+           stop
+         endif
+         if ((clouds.eq.0).and.(nmicro.lt.nrad)) then
+           print*,"OPTCV :"
+           print*,"nmicro < nrad"
+           print*,"Probleme pour zqaer_1pt dans optcv."
+           stop
+         endif
        endif
-
       
       DO 130 K=1,NSPECV
@@ -130,6 +143,10 @@
 C      XIMGV(K)=FITEDN(WLNV(K))
 C THE CLOUD IS CLEAR IN THE VISIBLE
-      RCLDV(K)=1.27
-      XICLDV(K)=1.E-7
+      CALL LIQCH4(WLNV(K),TNR,TNI)
+      RCLDV(K)=TNR
+      XICLDV(K)=TNI
+      CALL LIQC2H6(WLNV(K),TNR,TNI)
+      RCLDV2(K)=TNR
+      XICLDV2(K)=TNI
  130  CONTINUE
 C
@@ -150,10 +167,14 @@
       DO 101 ig=1,klon       !c! BOUCLE SUR GRILLE HORIZONTALE
 
-        if (microfi.eq.1) then
-           do iq=1,nrad
-	      do j=1,NLAYER
-	         zqaer_1pt(j,iq)=qaer(ig,j,iq)
-	      enddo
-	   enddo
+        if (microfi.ge.1) then
+           do iq=1,2*nrad
+             if (clouds.eq.0.and.iq.gt.nrad) then
+                zqaer_1pt(:,iq)=0.
+             else
+               do j=1,NLAYER
+                  zqaer_1pt(j,iq)=qaer(ig,j,iq)
+               enddo
+             endif
+           enddo
         else
          if (ig.eq.1)  then
@@ -181,26 +202,33 @@
 c       if ((microfi.eq.0).or.(ig.eq.klon/2)) iout=1
         if (seulmtunpt.eq.0) then
-	   call optcv_1pt(zqaer_1pt,ioptv,
-     .            COSBV_1pt,DTAUV_1pt,TAUHV_1pt,TAUHVD_1pt,TAUCV_1pt,
-     .       TAURV_1pt,TAUGV_1pt,TAUGVD_1pt,WBARV_1pt,TAUV_1pt,iout)
+          call optcv_1pt2(zqaer_1pt,rmcbar(ig,:),xfbar(ig,:,:),
+     &                   ioptv,IPRINT)
            ioptv = 1
 	endif
 
 c Pas de microphysique, ni de composition variable: un seul passage
-c dans optci_1pt.
+c dans optcv_1pt.
         if ((microfi.eq.0).and.(ylellouch)) then
 	   seulmtunpt = 1
 	endif
 	
-	COSBV(ig,:,:,:)= COSBV_1pt(:,:,:) 
-	WBARV(ig,:,:,:)= WBARV_1pt(:,:,:) 
-	DTAUV(ig,:,:,:)= DTAUV_1pt(:,:,:) 
-	TAUHV(ig,:)    = TAUHV_1pt(:) 
-	TAUCV(ig,:)    = TAUCV_1pt(:) 
-	TAURV(ig,:)    = TAURV_1pt(:) 
-	TAUGV(ig,:)    = TAUGV_1pt(:) 
-	TAUV(ig,:,:,:) = TAUV_1pt(:,:,:) 
-	TAUHVD(ig,:,:) = TAUHVD_1pt(:,:) 
-	TAUGVD(ig,:,:) = TAUGVD_1pt(:,:) 
+        COSBV(ig,:,:,:)= COSBV_1pt(:,:,:) 
+        WBARV(ig,:,:,:)= WBARV_1pt(:,:,:) 
+        DTAUV(ig,:,:,:)= DTAUV_1pt(:,:,:) 
+        TAUV(ig,:,:,:) = TAUV_1pt(:,:,:) 
+
+        COSBVP(ig,:,:,:)= COSBVP_1pt(:,:,:) 
+        WBARVP(ig,:,:,:)= WBARVP_1pt(:,:,:) 
+        DTAUVP(ig,:,:,:)= DTAUVP_1pt(:,:,:) 
+        TAUVP(ig,:,:,:) = TAUVP_1pt(:,:,:) 
+
+        TAUHV(ig,:)    = TAUHV_1pt(:) 
+        TAUCV(ig,:)    = TAUCV_1pt(:) 
+        TAURV(ig,:)    = TAURV_1pt(:) 
+        TAUGV(ig,:)    = TAUGV_1pt(:) 
+
+        TAUHVD(ig,:,:) = TAUHVD_1pt(:,:) 
+        TAUCVD(ig,:,:) = TAUCVD_1pt(:,:) 
+        TAUGVD(ig,:,:) = TAUGVD_1pt(:,:) 
 
  101  CONTINUE
